﻿using System;
using System.Linq;

namespace Task7
{
    class Program
    {

        public static int n, m;
        public static int[] Depth, Nodes;

        static void Main(string[] args)
        {
            string[] tmp = Console.ReadLine().Split();
            n = Convert.ToInt32(tmp[0]);
            m = Convert.ToInt32(tmp[1]);
            Depth = new int[n + 1];
            Nodes = new int[n + 1];
            tmp = Console.ReadLine().Split();
            Depth[0] = 0;
            Depth[1] = 1;
            Nodes[0] = -1;
            Nodes[1] = 0;
            int lmax = 0, lmaxind = 0;
            for (int i = 2; i <= n; i++)
            {
                int parent = Convert.ToInt32(tmp[i - 2]);
                Nodes[i] = parent;
                Depth[i] = Depth[parent] + 1;
                if (Depth[i] > lmax)
                {
                    lmax = Depth[i];
                    lmaxind = i;
                }
            }
            Depth[lmaxind] = 0;
            int p = Nodes[lmaxind];
            while (p != 1)
            {
                Depth[p] = 0;
                p = Nodes[p];
            }
            int lmin = 0;
            for (int i = 0; i < n; i++)
            {
                if (Depth[i] > lmin)
                {
                    lmin = Depth[i];
                }
            }
            if (lmin > 1)
            {
                Console.WriteLine(lmax * (2 * m - 1) + lmin - 1);
            }
            else
            {
                Console.WriteLine(lmax * m - (m - 1));
            }
#if DEBUG
            Console.ReadKey();
#endif
        }
    }
}
