﻿using System;
using System.Collections.Generic;

namespace Task3
{
    class Program
    {
        public class Empl
        {
            public int num;
            public int level;

            public Empl(int num, int level)
            {
                this.num = num;
                this.level = level;
            }
        }

        public static int n, m;
        public static SortedDictionary<int, List<Empl>> dict = new SortedDictionary<int, List<Empl>>();
        public static int[] result;

        static void Main(string[] args)
        {
            string[] tmp = Console.ReadLine().Split();
            n = Convert.ToInt32(tmp[0]);
            m = Convert.ToInt32(tmp[1]);
            result = new int[n];
            for (int i = 0; i < n; i++)
            {
                tmp = Console.ReadLine().Split();
                int tim = Convert.ToInt32(tmp[0]);
                if (dict[tim] == null) { dict[tim] = new List<Empl>(); }
                dict[Convert.ToInt32(tmp[0])].Add(new Empl(i, Convert.ToInt32(tmp[1])));
            }
            int time = 0;
            Dictionary<int, List<int>> dict2 = new Dictionary<int, List<int>>();
            start:
            foreach (var v in dict)
            {
                List<int> elevator = new List<int>();
                time += v.Key + 1;
                int prior = int.MaxValue;
                int lvl = 0;
                foreach(Empl e in v.Value)
                {
                    if (e.num < prior)
                    {
                        prior = e.num;
                        lvl = e.level;
                    }
                }
                foreach(Empl e in v.Value)
                {
                    if (dict2[e.level] == null) { dict2[e.level] = new List<int>(); }
                    dict2[e.level].Add(e.num);
                }
                for (; time <= lvl; time++)
                {
                    if (dict[time] != null)
                    {
                        foreach (Empl e in dict[time])
                        {
                            if (dict2[e.level] == null) { dict2[e.level] = new List<int>(); }
                            dict2[e.level].Add(e.num);
                        }
                        dict.Remove(time);
                    }
                }
                for (; lvl > 0; lvl--)
                {
                    dict2[lvl].ForEach((int i) => { elevator.Add(i); });
                    dict2.Remove(lvl);
                    time++;
                }
                foreach (int i in elevator)
                {
                    result[i] = time;
                }
                goto start;
            }
            foreach (int i in result)
            {
                Console.WriteLine(i);
            }
#if DEBUG
            Console.ReadKey();
#endif
        }
    }
}
