﻿using System;
using System.Collections.Generic;

namespace Task7
{
    class Program
    {
        public class Node
        {
            public Node Parent;
            public List<Node> Children;
            public int Depth;

            public Node(Node Parent)
            {
                this.Parent = Parent;
                Children = new List<Node>();
                Depth = Parent.Depth + 1;
            }

            public Node(int Depth)
            {
                Parent = null;
                Children = new List<Node>();
                this.Depth = Depth;
            }

            public int GetMaxDepth(Node Except)
            {
                if (Children.Count == 0) { return 1; }
                int result = 0;
                foreach (Node n in Children)
                {
                    if (n == Except) { continue; }
                    result = Math.Max(result, n.GetMaxDepth(Except));
                }
                return result == 0 ? 0 : result + 1;
            }
        }

        public static int n, m;
        //public static int[] Depth, Nodes;
        public static Node[] Nodes;

        static void Main(string[] args)
        {
            string[] tmp = Console.ReadLine().Split();
            n = Convert.ToInt32(tmp[0]);
            m = Convert.ToInt32(tmp[1]);
            Nodes = new Node[n + 1];
            Nodes[1] = new Node(1);
            tmp = Console.ReadLine().Split();
            int lmax = 0, lmaxind = 0;
            for (int i = 2; i < n + 1; i++)
            {
                int parentind = Convert.ToInt32(tmp[i - 2]);
                Nodes[i] = new Node(Nodes[parentind]);
                Nodes[parentind].Children.Add(Nodes[i]);
                if (Nodes[i].Depth > lmax)
                {
                    lmax = Nodes[i].Depth;
                    lmaxind = i;
                }
            }
            Node node = Nodes[lmaxind];
            int lmin = Nodes[1].GetMaxDepth(node);
            //int ind = lmaxind;
            //Node prev = null;
            //while (true)
            //{
            //    if (node.Parent == null)
            //    {

            //    }
            //    int depth;
            //    if ((depth = node.GetMaxDepth(prev)) >= Nodes[1].GetMaxDepth(node))
            //    {
            //        lmax = Nodes[lmaxind].Depth + depth - node.Depth * 2 + 1;
            //        break;
            //    }
            //    prev = Nodes[Array.IndexOf(Nodes, node)];
            //    node = node.Parent;
            //}
            //Console.Write(lmax);
            //Depth = new int[n + 1];
            //Nodes = new int[n + 1];
            //tmp = Console.ReadLine().Split();
            //Depth[0] = 0;
            //Depth[1] = 1;
            //Nodes[0] = -1;
            //Nodes[1] = 0;
            //int lmax = 0, lmaxind = 0;
            //for (int i = 2; i <= n; i++)
            //{
            //    int parent = Convert.ToInt32(tmp[i - 2]);
            //    Nodes[i] = parent;
            //    Depth[i] = Depth[parent] + 1;
            //    if (Depth[i] > lmax)
            //    {
            //        lmax = Depth[i];
            //        lmaxind = i;
            //    }
            //}
            //Depth[lmaxind] = 0;
            //int p = Nodes[lmaxind];
            //while (p != 1)
            //{
            //    Depth[p] = 0;
            //    p = Nodes[p];
            //}
            //int lmin = 0;
            //for (int i = 0; i < n; i++)
            //{
            //    if (Depth[i] > lmin)
            //    {
            //        lmin = Depth[i];
            //    }
            //}
            if (lmin > 1)
            {
                Console.WriteLine(lmax * (2 * m - 1) + lmin - 1);
            }
            else
            {
                Console.WriteLine(lmax * m);
            }
#if DEBUG
            Console.ReadKey();
#endif
        }
    }
}
