﻿using System;
using System.Collections.Generic;

namespace Task7
{
    class Program
    {
        public class Node
        {
            public Node Parent;
            public List<Node> Children;
            public int Depth;

            public Node(Node Parent)
            {
                this.Parent = Parent;
                Children = new List<Node>();
                Depth = Parent.Depth + 1;
            }

            public Node(int Depth)
            {
                Parent = null;
                Children = new List<Node>();
                this.Depth = Depth;
            }

            public int GetMaxDepth(Node Except, bool IsStart)
            {
                if (this == Except) { return 0; }
                if (Children.Count == 0) { return 1; }
                int result = 0;
                foreach (Node n in Children)
                {
                    if (n == Except) { continue; }
                    if (IsStart)
                    {
                        result = Math.Max(result, n.GetMaxDepth(Except, false));
                    }
                    else
                    {
                        int i = n.GetMaxDepth(Except, false);
                        if (i == 0) { break; }
                        result = Math.Max(result, i);
                    }
                }
                return result == 0 ? 0 : result + 1;
            }
        }

        public static int n, m;
        //public static int[] Depth, Nodes;
        public static Node[] Nodes;

        static void Main(string[] args)
        {
            string[] tmp = Console.ReadLine().Split();
            n = Convert.ToInt32(tmp[0]);
            m = Convert.ToInt32(tmp[1]);
            Nodes = new Node[n + 1];
            Nodes[1] = new Node(1);
            tmp = Console.ReadLine().Split();
            int max = 0, maxind = 0;
            for (int i = 2; i < n + 1; i++)
            {
                int parentind = Convert.ToInt32(tmp[i - 2]);
                Nodes[i] = new Node(Nodes[parentind]);
                Nodes[parentind].Children.Add(Nodes[i]);
                if (Nodes[i].Depth > max)
                {
                    max = Nodes[i].Depth;
                    maxind = i;
                }
            }
            Node node = Nodes[maxind];
            int min = Nodes[1].GetMaxDepth(node, true);
            int lmax = max, lmin = min;
            for(int i = 2; i < n+1;i++)
            {
                int tmin = Nodes[i].GetMaxDepth(node, true);
                int tmax = Nodes[i].GetMaxDepth(null, true);
                if (tmin+tmax>min+max)
                {
                    lmin = tmin;
                    lmax = tmax;
                }
            }
        //    Node node2 = Nodes[1];
        //    int counter = 0;
        //next:;
        //    counter++;
        //    foreach (Node n in node2.Children)
        //    {
        //        lmax = n.GetMaxDepth(null, false);
        //        if (lmax != max - counter) { continue; }
        //        lmin = n.GetMaxDepth(node, false);
        //        if (lmax + lmin == max + min - 2 * counter)
        //        {
        //            node2 = n;
        //            goto next;
        //        }
        //        lmax = node2.GetMaxDepth(null, false);
        //        lmin = node2.GetMaxDepth(node, false);
        //        break;
        //    }
            Console.WriteLine(max * 2 * (m - 1) + lmax + lmin - 1);
            //int ind = lmaxind;
            //Node prev = null;
            //while (true)
            //{
            //    if (node.Parent == null)
            //    {

            //    }
            //    int depth;
            //    if ((depth = node.GetMaxDepth(prev)) >= Nodes[1].GetMaxDepth(node))
            //    {
            //        lmax = Nodes[lmaxind].Depth + depth - node.Depth * 2 + 1;
            //        break;
            //    }
            //    prev = Nodes[Array.IndexOf(Nodes, node)];
            //    node = node.Parent;
            //}
            //Console.Write(lmax);
            //Depth = new int[n + 1];
            //Nodes = new int[n + 1];
            //tmp = Console.ReadLine().Split();
            //Depth[0] = 0;
            //Depth[1] = 1;
            //Nodes[0] = -1;
            //Nodes[1] = 0;
            //int lmax = 0, lmaxind = 0;
            //for (int i = 2; i <= n; i++)
            //{
            //    int parent = Convert.ToInt32(tmp[i - 2]);
            //    Nodes[i] = parent;
            //    Depth[i] = Depth[parent] + 1;
            //    if (Depth[i] > lmax)
            //    {
            //        lmax = Depth[i];
            //        lmaxind = i;
            //    }
            //}
            //Depth[lmaxind] = 0;
            //int p = Nodes[lmaxind];
            //while (p != 1)
            //{
            //    Depth[p] = 0;
            //    p = Nodes[p];
            //}
            //int lmin = 0;
            //for (int i = 0; i < n; i++)
            //{
            //    if (Depth[i] > lmin)
            //    {
            //        lmin = Depth[i];
            //    }
            //}
            //if (min > 1)
            //{
            //    Console.WriteLine(max * (2 * m - 1) + min - 1);
            //}
            //else
            //{
            //    Console.WriteLine(max * m);
            //}
#if DEBUG
            Console.ReadKey();
#endif
        }
    }
}
